package future.test;

/* Annick Fron
 * Utilisation d'un futur
 */

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

import junit.framework.TestCase;

import future.Calculateur;

public class TestFutur extends TestCase{
	   ExecutorService executor =Executors.newSingleThreadExecutor();
	   Calculateur calculateur= new Calculateur();

	public void testFutur() {

			try {
				new TestFutur().afficherResultat("calcul");
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	}


		   void afficherResultat(final String enonce) throws InterruptedException {
		     Future<String> future = executor.submit(new Callable<String>() {
		         public String call() { return calculateur.calcule(enonce); }
		     });
		     contructionFenetre(); // on fait d'autres choses en parallele
		     try {
		       afficheTexte(future.get()); // utilise le resultat du futur
		     } catch (ExecutionException ex) { ex.printStackTrace(); }
		   }


		private void contructionFenetre() {
			/* methode imaginaire qui prend du temps */
		}


		private void afficheTexte(String string) {
			System.out.println(string);
			
		}
		 

	}


