package reflexion.test;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import reflexion.Entite;

import junit.framework.TestCase;

public class TestReflexion extends TestCase {

	public void testMethodes() {
		Class c = java.lang.String.class;
		Method[] m1 = c.getDeclaredMethods();
		Method[] m2 = c.getMethods();

		try {
			Method method1 = String.class.getDeclaredMethod("indexOf",
					new Class[] { int.class });
			System.out.println(method1);
			Method method2 = String.class.getDeclaredMethod("indexOf",
					new Class[] { String.class, int.class });
			System.out.println(method2);
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void testInvocation() {
		// on va appeler toutes les methodes commencant par get sur l'entite
		Entite objet = new Entite();
		Method[] methods = objet.getClass().getMethods();
		for (int i = 0; i < methods.length; i++) {
			if (methods[i].getName().startsWith("get")) {
				try {
					Object value = methods[i].invoke(objet, (Object[]) null);// liste
																				// d'arguments																				// vide
					System.out.println(value);
				} catch (IllegalArgumentException e) {

					e.printStackTrace();
				} catch (IllegalAccessException e) {

					e.printStackTrace();
				} catch (InvocationTargetException e) {

					e.printStackTrace();
				}
			}

		}
	}
	
	public void testInvocation2() {
		Method m;
		try {
			m = String.class.getMethod("indexOf", new Class[] {String.class});
//			 on appelle la mthode avec le paramtre "bel" sur la chaine "un bel avenir"
			Object result=m.invoke("un bel avenir",new Object[] {"bel"}); 
		} catch (SecurityException e) {
		
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
		
			e.printStackTrace();
		} catch (IllegalArgumentException e) {

			e.printStackTrace();
		} catch (IllegalAccessException e) {
		
			e.printStackTrace();
		} catch (InvocationTargetException e) {

			e.printStackTrace();
		}


	}
}
