package serialisation;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;

/*
 * Annick Fron
 * Created on 26 janv. 2007
 *
 * permet de verifier que l'utilisation de transient protege des variables 
 * d'instance non Serializable
 */

public class FleurTransient implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private transient Thread activite;
	private String couleur;
	public FleurTransient(String uneCouleur) {
		couleur=uneCouleur;
	}

	public String getCouleur() {
		return couleur;
	}
	public void setCouleur(String couleur) {
		this.couleur = couleur;
	}


		public static void main(String[]args){
			// sauvegarde l'objet dans un fichier de nom fleur.ser
			FileOutputStream fos;
			try {
				fos = new FileOutputStream("fleur.ser");
				ObjectOutputStream out = new ObjectOutputStream(fos);
				out.writeObject(new FleurTransient("rouge"));
				out.close();
				fos.close();
			} catch (FileNotFoundException e) {
			
				e.printStackTrace();
			} catch (IOException e) {
		
				e.printStackTrace();
			}
	
		}

		public Thread getActivite() {
			return activite;
		}

		public void setActivite(Thread activite) {
			this.activite = activite;
		}
}
