/*
 * Created on 26 janv. 2007
 *
 * Annick Fron
 * Permet de tester des mthodes personnalises pour la serialisation
 * Implemente Externalizable au lieu de Serializable
 */
package serialisation;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class UserInfo implements Externalizable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String login="toto";
	private int id=1;
	private String motDePasse="passe";
	

	public void writeExternal(ObjectOutput out) throws IOException {
		out.writeObject(login);
		out.writeInt(id);
		byte[] crypte="".getBytes();
		try {
			crypte= MessageDigest.getInstance("MD5").digest(motDePasse.getBytes());
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		out.writeInt(crypte.length);
		out.write(crypte);
	}

	public void readExternal(ObjectInput in) throws IOException,
			ClassNotFoundException {
		login= (String) in.readObject();
		id=in.readInt();
		int taille=in.readInt();
		byte[] crypte=new byte[taille];
		in.read(crypte);
		motDePasse= crypte.toString();
		System.out.println(motDePasse);

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ByteArrayOutputStream bytes = new ByteArrayOutputStream();
		UserInfo info = new UserInfo();
		try {
			ObjectOutputStream outStream= new ObjectOutputStream(bytes);
			outStream.writeObject(info);
			ObjectInputStream inputStream= new ObjectInputStream(new ByteArrayInputStream(bytes.toByteArray()));
			UserInfo var= (UserInfo)inputStream.readObject();
			System.out.println(info);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
		public String toString() {
			return login+" "+id;
		}

	}


