/*
 * Created on 26 janv. 2007
 * Annick Fron
 * Teste que la serialisation preserve l'identite des references
 * 
 */
package serialisation.test;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import serialisation.Fleur;
import serialisation.Variete;


import junit.framework.TestCase;

public class TestReference extends TestCase {
	public void ecritureFichier() {
		// ecriture d'un objet serialise dans un fichier
		try {
		
			FileOutputStream fos = new FileOutputStream("fleur.ser");
			ObjectOutputStream out = new ObjectOutputStream(fos);
			out.writeObject(new Fleur("rouge"));
			out.close();
			fos.close();
		} catch (FileNotFoundException e) {
		
			e.printStackTrace();
		} catch (IOException e) {
	
			e.printStackTrace();
		}
		
	}
	public void testEgalite() {
		Variete variete = new Variete();
		variete.ajout(new Fleur("rouge"));
		variete.ajout(new Fleur("vert"));
		variete.ajout(new Fleur("rouge"));
		variete.ajout(new Fleur("bleu"));
		
		//on serialise
		ByteArrayOutputStream bytes = new ByteArrayOutputStream();
		try {
			ObjectOutputStream outStream= new ObjectOutputStream(bytes);
			outStream.writeObject(variete);
			ObjectInputStream inputStream= new ObjectInputStream(new ByteArrayInputStream(bytes.toByteArray()));
			Variete var= (Variete)inputStream.readObject();
			assertEquals(var.premiere().getVariete(),var);
		} catch (IOException e) {
		
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
	
			e.printStackTrace();
		}
		
	}

}
