/*
 * Created on 26 janv. 2007
 * Annick Fron
 * Test de serialisation dans un fichier et dans un buffer
 * 
 */
package serialisation.test;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import serialisation.Fleur;
import serialisation.FleurSimple;

import junit.framework.TestCase;

public class TestSimple extends TestCase {
public void testEcritureFichier() {
	/* ecriture d'un objet dans un fichier */
	FleurSimple fleur = new FleurSimple("Coquelicot");
	FileOutputStream fos;
	try {
		fos = new FileOutputStream("fleur.ser");
		ObjectOutputStream out = new ObjectOutputStream(fos);
		out.writeObject(new Fleur("rouge"));
		out.close();
		fos.close();

	} catch (FileNotFoundException e) {
	
		e.printStackTrace();
	} catch (IOException e) {
	
		e.printStackTrace();
	}
	
}

public void testLectureEcritureDansBuffer() {
	/* test de l'ecriture et de la lecture de l'objet dans un buffer */
	ByteArrayOutputStream bytes = new ByteArrayOutputStream();
	ObjectOutputStream outStream;
	try {
		outStream = new ObjectOutputStream(bytes);
		outStream.writeObject(new FleurSimple("rouge"));
		ObjectInputStream inputStream= new ObjectInputStream(new   
		    ByteArrayInputStream(bytes.toByteArray()));
		FleurSimple fleur= (FleurSimple)inputStream.readObject();
	} catch (IOException e) {

		e.printStackTrace();
	} catch (ClassNotFoundException e) {

		e.printStackTrace();
	}	
}


}
