package sync;


/* Annick Fron
 * permet de tester que sans synchronisation le solde n'est pas constant
 * 
 */

public class TestGestionnaireDeFond implements ConstantesFond {

    public static Transfer transfers[] = 
				new Transfer[transfertsAleatoires];
    static {
        for (int n=0; n<transfertsAleatoires; n++) {
            transfers[n] = new Transfer();
        }
    }

    public static void main(String [] args) {
        Thread[] threads = new Thread[nbGestionnaires];
        GestionnaireDeFond[] mgrs = new GestionnaireDeFond[nbGestionnaires];
        for (int n=0; n<nbGestionnaires; n++) {
            mgrs[n] = new GestionnaireDeFond("Gestionnaire " + n);
            threads[n] = new Thread(mgrs[n]);
	    //WARNING! You would rarely call setPriority in production code
	    threads[n].setPriority(1 + (int)(Math.random() * 4));
            threads[n].start();
        }
        for (int n=0; n<dureeTest; n++) {
            try {
                Thread.sleep(1000);
                Actions.checkSystem();
            }
            catch (InterruptedException ie) {}
        }
        System.out.println();
        for (int n=0; n<nbGestionnaires; n++) {
            threads[n].interrupt();
        }
        for (int n=0; n<nbGestionnaires; n++) {
            try {
		threads[n].join();
	        } catch (InterruptedException ie) {}
        }
        long throughput = 0;
        for (int n=0; n<nbGestionnaires; n++) {
            throughput += mgrs[n].throughput;
        }
        Actions.checkSystem();
        System.out.println("Total transactions " + throughput);
    }
}