package forkjoin;

//http://www.insideit.fr/post/2008/09/15/Java-7-Fork/Join-%3A-Exploiter-toute-la-puissance

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveAction;

public class Fibonacci extends RecursiveAction {
	protected  static int SEUIL= 10;
	volatile private int nombre;
	volatile private int resultat;
	public Fibonacci(int unEntier){
		nombre= unEntier;
	}
	@Override
	protected void compute() {
		 int n = nombre;
	        if (nombre <= SEUIL) { // seuil de granularit sous lequel on ne paralllise plus
	            resultat = calculElementaire(n);
	        } else {
	            final Fibonacci f1 = new Fibonacci(n - 1); // subdivision
	            final Fibonacci f2 = new Fibonacci(n - 2);
	            invokeAll(f1, f2); // invocation en parallle des sous-taches (fork & join)
	            resultat = f1.resultat() + f2.resultat(); // agregation des resultats
	        }
	}

	private int calculElementaire(int n){
        if (n <= 1) {
            return n;
        } else {
            return calculElementaire(n - 1) + calculElementaire(n - 2);}
       }
	public int resultat(){ return resultat;}
	
	public static void main(String[] args) {
		int tailleGroupe = 2; // essayer par exemple Runtime.getRuntime().availableProcessors() too
        ForkJoinPool pool = new ForkJoinPool(tailleGroupe);
        Fibonacci f = new Fibonacci(44); // par exemple
        long depart = System.currentTimeMillis();
        pool.invoke(f);
        int resultatDefinitif = f.resultat();
        System.out.println("Reponse : " + resultatDefinitif);
        long fin = System.currentTimeMillis();
        System.out.println("Temps de calcul :"+(fin-depart));

	}

}
